/*
Horizontal Spring fixes
	by Lach
*/

if rawget(_G, "hspringfix") return end

rawset(_G, "hspringfix", true)

local springers = {}

addHook("MobjMoveCollide", function(mo, spring)
	if mo.valid and mo.player and spring and spring.valid and spring.flags & MF_SPRING and spring.flags & MF_SOLID and not mobjinfo[spring.type].mass and mo.z <= spring.z + spring.height and mo.z + mo.height >= spring.z
		mo.springflags = mo.player.pflags
		table.insert(springers, mo)
	end
end, MT_PLAYER)

addHook("ThinkFrame", do
	for i = 1, table.maxn(springers)
		if springers[i] and springers[i].valid and springers[i].springflags and springers[i].player
			springers[i].player.pflags = springers[i].springflags
			springers[i].springflags = nil
		end
	end
	springers = {}
end)